=== debian/changelog ===
flint (2.8.4-2build1) jammy; urgency=medium

  * No change rebuild for newer libntl44

 -- Bryce Harrington <bryce@canonical.com>  Thu, 09 Dec 2021 01:45:13 +0000

flint (2.8.4-2) unstable; urgency=medium

  * Source-only upload to migrate to testing.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 01 Dec 2021 07:04:32 +0100

flint (2.8.4-1) unstable; urgency=medium

  * New upstream release.
  * Drop most patches (updated).
  * Adapt to soname version.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 17 Nov 2021 21:45:55 +0100

flint (2.8.3-2) unstable; urgency=medium

  * Remove the C++ documentation more cleanly.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 06 Nov 2021 16:51:03 +0100

flint (2.8.3-1) unstable; urgency=medium

  * Move the package to the new math team.
  * New upstream release.
  * Drop the documentation for the C++ wrapper.
  * Adapt to he new version.
  * Add lintian overrides to document some things are normal.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 06 Nov 2021 16:43:34 +0100

flint (2.8.2-2) unstable; urgency=medium

  * Fix d/watch.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 25 Oct 2021 09:58:39 +0200

flint (2.8.2-1) unstable; urgency=medium

  [ John Scott ]
  * Add a DEP-8 test exercising some functionality of FLINT.

  [ Julien Puydt ]
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 16 Oct 2021 13:10:37 +0200

flint (2.8.1-1) unstable; urgency=medium

  * New upstream release.
  * Add b-dep on tex-gyre for the documentation.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 02 Oct 2021 18:44:09 +0200

flint (2.8.0-2) unstable; urgency=medium

  * Source-only upload for testing migration.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 31 Aug 2021 13:02:58 +0200

flint (2.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump std-vers to 4.6.0.
  * Rework doc installation (Closes: #990665).
  * Add unbreak_doc.patch to unbreak doc compilation.
  * Update packages versions in control file.
  * Update d/copyright.
  * Rewrite d/watch to check upstream's git repository.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 20 Aug 2021 00:19:07 +0200

flint (2.7.1-1) experimental; urgency=medium

  * New upstream release.
  * Add a workaround for upstream bug #889 (Closes: #979465)

 -- Julien Puydt <jpuydt@debian.org>  Wed, 27 Jan 2021 11:11:43 +0100

flint (2.7.0-2) experimental; urgency=medium

  * Follow soname number change.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 28 Dec 2020 09:04:51 +0100

flint (2.7.0-1) experimental; urgency=medium

  * New upstream release.
  * Bump std-vers to 4.5.1.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 25 Dec 2020 22:17:17 +0100
