=== debian/watch ===
version=4
https://github.com/wbhart/flint2/tags .*/v?(\d[-\d.]*)\.tar\.gz
