=== debian/changelog ===
flint (2.9.0-5) unstable; urgency=medium

  * Add patch to fix a floating-point exception (Closes: #1016296).

 -- Julien Puydt <jpuydt@debian.org>  Sun, 11 Sep 2022 13:46:29 +0200

flint (2.9.0-4) unstable; urgency=medium

  * Fix multiarch (Closes: #1014919).
  * Add patch to remove rpath linking switch.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 14 Jul 2022 20:58:01 +0200

flint (2.9.0-3) unstable; urgency=medium

  * Drop references to EXTRA_SHARED_FLAGS from d/rules (Closes: #1014917).

 -- Julien Puydt <jpuydt@debian.org>  Thu, 14 Jul 2022 17:08:12 +0200

flint (2.9.0-2) unstable; urgency=medium

  * Re-upload to unstable.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 08 Jul 2022 21:11:29 +0200

flint (2.9.0-1) experimental; urgency=medium

  * New upstream release.
  * Remove source lintian overrides.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 24 Jun 2022 19:32:04 +0200

flint (2.9.0~beta1-1) experimental; urgency=medium

  * Package upstream pre-release (big changes announced).
  * Move to usual soname numbering for the library.
  * Bump standards-version to 4.6.1.
  * Adapt lintian-overrides.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 19 May 2022 14:15:13 +0200

flint (2.8.5-2) unstable; urgency=medium

  * Source-only upload to migrate to testing.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 14 May 2022 03:55:15 +0200

flint (2.8.5-1) unstable; urgency=medium

  * Point Vcs-* fields to the math-team too.
  * New upstream release.
  * Cope with the soname change.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 01 May 2022 21:38:46 +0200
