=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: flint
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Homepage: http://www.flintlib.org/
 Build-Depends: debhelper-compat (= 13),
@@ -14,17 +13,16 @@
                python3-sphinx,
                texlive-fonts-recommended,
                texlive-latex-extra
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
-Vcs-Browser: https://salsa.debian.org/science-team/flint
-Vcs-Git: https://salsa.debian.org/science-team/flint.git
+Vcs-Browser: https://salsa.debian.org/math-team/flint
+Vcs-Git: https://salsa.debian.org/math-team/flint.git
 
-Package: libflint-2.8.4
+Package: libflint17
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Replaces: libflint-2.6.3, libflint-2.7.0, libflint-2.7.1, libflint-2.8.0, libflint-2.8.1, libflint-2.8.2, libflint-2.8.3
 Description: C library for number theory, shared library
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring
@@ -39,7 +37,7 @@
 Package: libflint-dev
 Section: libdevel
 Architecture: any
-Depends: libflint-2.8.4 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
+Depends: libflint17 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
 Description: C library for number theory, development files
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring
