=== debian/changelog ===
flint (3.0.1-3) unstable; urgency=medium

  * Fix multi-arch support.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 04 Feb 2024 16:08:09 +0100

flint (3.0.1-2) unstable; urgency=medium

  * Team upload.
  * debian/tests/matrix-bernoulli.c
    - Add missing headers (Closes: #1058580).

 -- Doug Torrance <dtorrance@debian.org>  Wed, 10 Jan 2024 00:49:55 -0500

flint (3.0.1-1) unstable; urgency=medium

  * Bump standards-version to 4.6.2.
  * New upstream release (Closes: #1019969).
  * Refresh patches.
  * Ship flint.pc.
  * Fix build target (Closes: #1044581).

 -- Julien Puydt <jpuydt@debian.org>  Sat, 09 Dec 2023 16:10:56 +0100
