=== debian/control ===
--- 
+++ 
@@ -13,12 +13,12 @@
                python3-sphinx,
                texlive-fonts-recommended,
                texlive-latex-extra
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/math-team/flint
 Vcs-Git: https://salsa.debian.org/math-team/flint.git
 
-Package: libflint17
+Package: libflint18
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -37,7 +37,7 @@
 Package: libflint-dev
 Section: libdevel
 Architecture: any
-Depends: libflint17 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
+Depends: libflint18 (= ${binary:Version}), libmpfr-dev, ${misc:Depends}
 Description: C library for number theory, development files
  The Fast Library for Integer Number Theory is a C library which supports
  polynomial arithmetic over the integers, fast integer arithmetic and factoring
